// Copyright (c) 1999, A.H. van den Boogaard

#include "drawshape.h"

void DrawTri_lin::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 3 );
   points[0] = 0;
   points[1] = 1;
   points[2] = 2;
}

void DrawTri_quad::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 6 );
   points[0] = 0;
   points[1] = 1;
   points[2] = 2;
   points[3] = 3;
   points[4] = 4;
   points[5] = 5;
}

void DrawTri_quad_alt::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 6 );
   points[0] = 0;
   points[1] = 3;
   points[2] = 1;
   points[3] = 4;
   points[4] = 2;
   points[5] = 5;
}

void DrawQuad_lin::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 4 );
   points[0] = 0;
   points[1] = 1;
   points[2] = 2;
   points[3] = 3;
}

void DrawQuad_quad::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 8 );
   points[0] = 0;
   points[1] = 1;
   points[2] = 2;
   points[3] = 3;
   points[4] = 4;
   points[5] = 5;
   points[6] = 6;
   points[7] = 7;
}

void DrawQuad_quad_alt::get_draw_points( std::vector<int>& points ) const
{
   points.resize( 8 );
   points[0] = 0;
   points[1] = 4;
   points[2] = 1;
   points[3] = 5;
   points[4] = 2;
   points[5] = 6;
   points[6] = 3;
   points[7] = 7;
}

