// Copyright (c) 2005, A.H. van den Boogaard

#ifndef MODAL_H
#define MODAL_H

#include "ftmatrix.h"

class Mode
{
   public:
      double          eigenvalue;
      FeaTure::Vector mode;

      Mode():eigenvalue(0){}
      Mode(size_t dim):eigenvalue(0){ mode.resize(dim); mode.clear(); }
      ~Mode(){}
};

class CompareModePtrs
{
   public:
      bool operator()( const Mode* m1, const Mode* m2 ) const
        { return m1->eigenvalue < m2->eigenvalue; }
};

class CompareModePtrsAbsolute
{
   public:
      bool operator()( const Mode* m1, const Mode* m2 ) const
        { return std::abs(m1->eigenvalue) < std::abs(m2->eigenvalue); }
};

#endif /* MODAL_H */
