// Copyright (c) 1999, A.H. van den Boogaard

#ifndef MYELMBASE_H
#define MYELMBASE_H

#include "elembase.h"


#ifdef FT_GUI
// needed for Borland 5.5 with wxWindows 2.2; namespace issue?
using std::streambuf;
using std::ostream;

#include "screenmap.h"
#include "wx/dc.h"
#endif

class FiniteElement:public FeaTure::ElementBase
{
   protected:
      typedef FeaTure::Node* Node_ptr;
      static int total_ip_nr;

      FiniteElement(){}
      FiniteElement( int nr, Node_ptr *ElNodes, int nr_of_ElNodes,
            int nr_dofs ):FeaTure::ElementBase( nr, ElNodes, nr_of_ElNodes,
                                                nr_dofs ){}

   public:
      ~FiniteElement(){}

      virtual void PrintStress( std::ostream& /*out*/ ) const { return; }
      virtual void PrintStressHeader( std::ostream& /*out*/ ) const { return; }
      virtual void PrintXpStress( std::ostream& /*out*/ ) const { return; }
      virtual void PrintXpStressHeader( std::ostream& /*out*/ ) const { return; }
      virtual void PrintPostFile( std::ostream& /*out*/ ) const { return; }
      virtual void PrintPostHeader( std::ostream& /*out*/, int /*stepnr*/ ) const { return; }
 
      virtual void print( std::ostream& out ) const;

#ifdef FT_GUI
      virtual void Draw( wxDC& dc, const DeviceMap& map, bool numbered ) const=0;
      virtual void DrawDispl( wxDC& /*dc*/, const DeviceMap& /*map*/,
                         bool /*numbered*/, float /*magnif*/ ) const { return; }
#endif
};

#endif // MYELMBASE_H
