// Copyright (c) 1999, A.H. van den Boogaard

#include "screenmap.h"
#include <algorithm>

void    DeviceMap::setOrigin( float x, float y ){ x0=x; y0=y; }
void    DeviceMap::setScale( float s ){ scale = std::max(double(s),1E-10); }

wxCoord DeviceMap::toScreen( float size ) const { return wxCoord(size*scale); }
wxCoord DeviceMap::XtoScreen( float x ) const
{
   wxCoord xs = wxCoord(x*scale-x0);
   if ( xs < -10000 ) xs = -10000;
   else if ( xs > 10000 ) xs = 10000;
   return xs;
}
wxCoord DeviceMap::YtoScreen( float y ) const
{
   wxCoord ys = wxCoord(-y*scale+y0);
   if ( ys < -10000 ) ys = -10000;
   else if ( ys > 10000 ) ys = 10000;
   return ys;
//   return -y*scale+y0;
}
wxPoint DeviceMap::toScreen( float x, float y ) const
{
   wxPoint pt;
   pt.x = (int)XtoScreen(x);
   pt.y = (int)YtoScreen(y);
   return pt;
}
//wxPoint DeviceMap::toScreen( wxPoint pt ) const { return toScreen(pt.x,pt.y); }

float   DeviceMap::toX( float x ) const { return (x+x0)/scale; }
float   DeviceMap::toY( float y ) const { return (y0-y)/scale; }
wxPoint DeviceMap::toPhys( wxPoint pt ) const
{
   wxPoint PhysPt;
   PhysPt.x = (int)toX( pt.x );
   PhysPt.y = (int)toY( pt.y );
   return PhysPt;
}
void    DeviceMap::toPhys( float &x, float &y ) const 
{
   x = toX(x);
   y = toY(y);
}

void    DeviceMap::shiftLeft( float deltaX ){ x0 += deltaX; }
void    DeviceMap::shiftUp( float deltaY ){ y0 -= deltaY; }
void    DeviceMap::zoom( float factor ){scale *= factor; }

