// Copyright (c) 2000, A.H. van den Boogaard

#ifndef FTEXCEPT_H
#define FTEXCEPT_H

#include <exception>
#include <string>

namespace FeaTure
{

class feature_error:public std::exception
{
   private:
      std::string message;

   public:
      feature_error( const std::string& what_arg ):message(what_arg){}
      const char* what() const throw() { return message.c_str(); }
      ~feature_error() throw(){}
};

class file_error:public feature_error
{
   public:
      file_error( const std::string& what_arg ):feature_error(what_arg){}
      ~file_error() throw(){}
};

class program_error:public feature_error
{
   public:
      program_error( const std::string& what_arg ):feature_error(what_arg){}
      ~program_error() throw(){}
};

class not_implemented_error:public program_error
{
   public:
      not_implemented_error( const std::string& what_arg ):program_error(what_arg){}
      ~not_implemented_error() throw(){}
};

class dimension_error:public program_error
{
   public:
      dimension_error( const std::string& what_arg ):program_error(what_arg){}
      ~dimension_error() throw(){}
};

class matrix_error:public feature_error
{
   public:
      matrix_error( const std::string& what_arg ):feature_error(what_arg){}
      ~matrix_error() throw(){}
};

class not_found:public feature_error
{
   public:
      not_found( const std::string& what_arg ):feature_error(what_arg){}
      ~not_found() throw(){}
};

} // namespace FeaTure

#endif // FTEXCEPT_H
