// Copyright (c) 1999, A.H. van den Boogaard

#ifndef INTPOINT_H
#define INTPOINT_H

#include "ftmatrix.h"

namespace FeaTure
{

void Gauss( int ip, int nip, double& xi, double& weight );

void Hammer( int ip, int nip, double& L1, double& L2, double& L3,
             double& weight );

class IntLocs
{
   class int_loc
   { 
      public:
         int_loc(){};
         ~int_loc(){};
         Vector nat_coord;
         double weight;
   };

   private:
      int nr_of_intpt;
      int_loc *intpts;

   public:
      IntLocs();
      IntLocs( const IntLocs& );
      IntLocs( int nr );
      ~IntLocs();

      void set_nr_intpt( int nr );
      int  get_nr_intpt() const;
      void set_values( int ip, Vector coor, double weight );
      Vector get_coor(int ip) const;
      double get_weight(int ip) const;
};

} // namespace FeaTure

#endif /* INTPOINT_H */
