// Copyright (c) 1999, A.H. van den Boogaard

#ifndef NONSYM_H
#define NONSYM_H

#include "ftmatrix.h"
#include "sysmat.h"

namespace FeaTure
{

class SkyNonSymMat:public SystemMat
{
   private:
      size_t *p;
      size_t size;
      bool decomposed;
      double **L;
      double **U;

      void create_mem();
      double dget(size_t i, size_t j) const;
      void dput(size_t i, size_t j, double a);
      int  LU_factor();
      int  LU_solve( Vector& x ) const;

   public:
      SkyNonSymMat():p(NULL),size(0),decomposed(false),L(NULL),U(NULL){}
      SkyNonSymMat( size_t n );
      ~SkyNonSymMat();

      void init(size_t row, size_t col);
      void clear();
      void add(size_t row, size_t col, double value);
      void print( char *name ) const;
      void solve( const Vector& rhs, Vector& x );
};

} // namespace FeaTure

#endif // NONSYM_H
