// Copyright (c) 1999, A.H. van den Boogaard

#ifndef STPSELECT_H
#define STPSELECT_H

#include <set>

namespace FeaTure
{

class StepSelect
{
   private:
      std::set< int,std::less<int> > select_set;
      /* second argument should be default but
         templated defaults do not work in BC++ 5.02 */
      bool select_all, select_last;

   public:
      StepSelect():select_all(false),select_last(false){}
      ~StepSelect(){}

      void add_step( int step ){ select_set.insert( step ); }
      void add_all_steps(){ select_all = true; }
      void add_last_step(){ select_last = true; }
      bool is_selected( int step, bool is_last ) const
         { return select_all || ( select_last && is_last ) || select_set.count( step ); }
      bool any_selected() const { return select_all || select_last || !select_set.empty(); }
};

} // namespace FeaTure

#endif /* STPSELECT_H */
